Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_iso_crs.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_iso_crs.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_iso_crs.F90	(revision 5601)
@@ -19,10 +19,10 @@
    !!                  the isopycnal or geopotential s-coord. operator 
    !!----------------------------------------------------------------------
-   USE oce             ! ocean dynamics and active tracers
-   USE dom_oce         ! ocean space and time domain
-   USE trc_oce         ! share passive tracers/Ocean variables
-   USE zdf_oce         ! ocean vertical physics
-   USE ldftra_oce      ! ocean active tracers: lateral physics
- !  USE ldfslp          ! iso-neutral slopes
+!   USE oce             ! ocean dynamics and active tracers
+!   USE dom_oce         ! ocean space and time domain
+!   USE trc_oce         ! share passive tracers/Ocean variables
+!   USE zdf_oce         ! ocean vertical physics
+!   USE ldftra_oce      ! ocean active tracers: lateral physics
+!   USE ldfslp          ! iso-neutral slopes
    USE ldfslp_crs          ! iso-neutral slopes
    USE diaptr          ! poleward transport diagnostics
@@ -35,5 +35,7 @@
    USE wrk_nemo        ! Memory Allocation
    USE timing          ! Timing
-   USE crs
+!   USE crs
+   USE oce_trc
+   USE iom, ONLY : iom_put,iom_swap
 
    IMPLICIT NONE
@@ -94,5 +96,4 @@
       !! ** Action :   Update pta arrays with the before rotated diffusion
       !!----------------------------------------------------------------------
-      USE oce     , ONLY:   zftu => ua       , zftv  => va         ! (ua,va) used as workspace
       !
       INTEGER                              , INTENT(in   ) ::   kt         ! ocean time-step index
@@ -113,5 +114,5 @@
 #endif
       REAL(wp), POINTER, DIMENSION(:,:  ) ::  zdkt, zdk1t, z2d
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::  zdit, zdjt, ztfw 
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::  zdit, zdjt, ztfw , zftu,  zftv 
       !!----------------------------------------------------------------------
       !
@@ -119,5 +120,5 @@
       !
       CALL wrk_alloc( jpi, jpj,      zdkt, zdk1t, z2d ) 
-      CALL wrk_alloc( jpi, jpj, jpk, zdit, zdjt, ztfw  ) 
+      CALL wrk_alloc( jpi, jpj, jpk, zdit, zdjt, ztfw , zftu, zftv ) 
       !
 
@@ -149,7 +150,4 @@
             END DO
          END DO
-    !    WRITE(numout,*) ' test1 ', zdit
-!cc commenté pour le test concluant de TMP16 --> pgu mauvais, correction dans
-!zpshde_crs ( probleme de signe lorsque ze3wu negatif, de mem pour pgv)
          IF( ln_zps ) THEN      ! partial steps correction at the last ocean level 
             DO jj = 1, jpjm1
@@ -160,6 +158,4 @@
             END DO
          ENDIF
-!cc
-     !   WRITE(numout,*) ' test2 ', zdit
 
          !!----------------------------------------------------------------------
@@ -183,8 +179,6 @@
             DO jj = 1 , jpjm1
                DO ji = 1, fs_jpim1   ! vector opt.
-   !               zabe1 = ( fsahtu(ji,jj,jk) + pahtb0 ) * e2e3u_msk(ji,jj,jk) / e1u_crs(ji,jj)
-  zabe1 = ( fsahtu(ji,jj,jk) + pahtb0 ) * e2e3u_msk(ji,jj,jk) / e1u_crs(ji,jj)
- !               zabe2 = ( fsahtv(ji,jj,jk) + pahtb0 ) * e1e3v_msk(ji,jj,jk) / e2v_crs(ji,jj)
-zabe2 = ( fsahtv(ji,jj,jk) + pahtb0 ) * e1e3v_msk(ji,jj,jk) / e2v_crs(ji,jj)
+                  zabe1 = ( fsahtu(ji,jj,jk) + pahtb0 ) * e2e3u_msk(ji,jj,jk) / e1u_crs(ji,jj)
+                  zabe2 = ( fsahtv(ji,jj,jk) + pahtb0 ) * e1e3v_msk(ji,jj,jk) / e2v_crs(ji,jj)
 
                   zmsku = 1. / MAX(  tmask_crs(ji+1,jj,jk  ) + tmask_crs(ji,jj,jk+1)   &
@@ -194,10 +188,6 @@
                      &             + tmask_crs(ji,jj+1,jk+1) + tmask_crs(ji,jj,jk  ), 1. )
                   !
-    !              zcof1 = - fsahtu(ji,jj,jk) * e2e3u_msk(ji,jj,jk) * uslp_crs(ji,jj,jk) * zmsku / MAX( 1._wp , e3u_max_crs(ji,jj,jk)) vue avec Gurvan OK
-                zcof1 = - fsahtu(ji,jj,jk) * e2e3u_msk(ji,jj,jk) * uslp_crs(ji,jj,jk) * zmsku / MAX( 1._wp , e3u_max_crs(ji,jj,jk))
-  !                zcof2 = - fsahtv(ji,jj,jk) * e1e3v_msk(ji,jj,jk) * vslp_crs(ji,jj,jk) * zmskv / MAX( 1._wp , e3v_max_crs(ji,jj,jk))  vue avec Gurvan OK
-                zcof2 = - fsahtv(ji,jj,jk) * e1e3v_msk(ji,jj,jk) * vslp_crs(ji,jj,jk) * zmskv / MAX( 1._wp , e3v_max_crs(ji,jj,jk))
-           !        zcof1 = - fsahtu(ji,jj,jk) * e2u_crs(ji,jj) * uslp(ji,jj,jk) * zmsku
-           !        zcof2 = - fsahtv(ji,jj,jk) * e1v_crs(ji,jj) * vslp(ji,jj,jk) * zmskv  
+                  zcof1 = - fsahtu(ji,jj,jk) * e2e3u_msk(ji,jj,jk) * uslp_crs(ji,jj,jk) * zmsku / MAX( 1._wp , e3u_max_crs(ji,jj,jk))
+                  zcof2 = - fsahtv(ji,jj,jk) * e1e3v_msk(ji,jj,jk) * vslp_crs(ji,jj,jk) * zmskv / MAX( 1._wp , e3v_max_crs(ji,jj,jk))
                   !
                   zftu(ji,jj,jk ) = ( zabe1 * zdit(ji,jj,jk)   &
@@ -209,4 +199,8 @@
                END DO
             END DO
+            CALL iom_swap( "nemo_crs"  )
+            CALL iom_put( "zftu" , zftu )
+            CALL iom_put( "zftv" , zftv )
+            CALL iom_swap( "nemo" )
 
             ! II.4 Second derivative (divergence) and add to the general trend
@@ -285,6 +279,4 @@
                   zcoef3 = zcoef0 * e1e2w_crs(ji,jj,jk) * zmsku * wslpi_crs(ji,jj,jk) / e1t_crs(ji,jj)
                   zcoef4 = zcoef0 * e1e2w_crs(ji,jj,jk) * zmskv * wslpj_crs(ji,jj,jk) / e2t_crs(ji,jj)
-           !       zcoef3 = zcoef0 * e2t_crs(ji,jj) * zmsku * wslpi (ji,jj,jk)
-           !       zcoef4 = zcoef0 * e1t_crs(ji,jj) * zmskv * wslpj (ji,jj,jk)
                   ztfw(ji,jj,jk) = zcoef3 * (   zdit(ji  ,jj  ,jk-1) + zdit(ji-1,jj  ,jk)      &
                      &                        + zdit(ji-1,jj  ,jk-1) + zdit(ji  ,jj  ,jk)  )   &
@@ -312,5 +304,5 @@
       !
       CALL wrk_dealloc( jpi, jpj,      zdkt, zdk1t, z2d ) 
-      CALL wrk_dealloc( jpi, jpj, jpk, zdit, zdjt, ztfw  ) 
+      CALL wrk_dealloc( jpi, jpj, jpk, zdit, zdjt, ztfw , zftu, zftv ) 
       !
       IF( nn_timing == 1 )  CALL timing_stop('tra_ldf_iso')
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/trazdf_imp_crs.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/trazdf_imp_crs.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/trazdf_imp_crs.F90	(revision 5601)
@@ -78,5 +78,4 @@
       !! ** Action  : - pta  becomes the after tracer
       !!---------------------------------------------------------------------
-      USE oce     , ONLY:   zwd => ua       , zws => va         ! (ua,va) used as 3D workspace
       !
       INTEGER                              , INTENT(in   ) ::   kt       ! ocean time-step index
@@ -90,11 +89,10 @@
       INTEGER  ::  ji, jj, jk, jn   ! dummy loop indices
       REAL(wp) ::  zrhs, ze3tb, ze3tn, ze3ta   ! local scalars
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::  zwi, zwt
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::  zwi, zwt,zwd,zws
       !!---------------------------------------------------------------------
       !
-!WRITE(numout,*) 'test6456_trb_sbc1', pta(:,:,:,1), kt
-      IF( nn_timing == 1 )  CALL timing_start('tra_zdf_imp')
-      !
-      CALL wrk_alloc( jpi, jpj, jpk, zwi, zwt ) 
+      IF( nn_timing == 1 )  CALL timing_start('tra_zdf_imp_crs')
+      !
+      CALL wrk_alloc( jpi, jpj, jpk, zwi, zwt, zwd, zws ) 
       !
       IF( kt == kit000 )  THEN
@@ -121,7 +119,5 @@
             ! vertical mixing coef.: avt for temperature, avs for salinity and passive tracers
             IF( cdtype == 'TRA' .AND. jn == jp_tem ) THEN   ;   zwt(:,:,2:jpk) = avt  (:,:,2:jpk)
-#if defined key_zdfddm
-            ELSE                                            ;   zwt(:,:,2:jpk) = avs_crs(:,:,2:jpk)
-#endif
+            ELSE                                            ;   zwt(:,:,2:jpk) = avt_crs(:,:,2:jpk)
             ENDIF
             zwt(:,:,1) = 0._wp
@@ -135,5 +131,4 @@
                      DO ji = fs_2, fs_jpim1   ! vector opt.
                         zwt(ji,jj,jk) = zwt(ji,jj,jk) + ah_wslp2(ji,jj,jk) 
-    !                    WRITE(numout,*) 'ah_wslp2', ah_wslp2(ji,jj,jk)      
                      END DO
                   END DO
@@ -152,32 +147,17 @@
 
 #endif
-!WRITE(numout,*) 'test6456_trb_sbc2', pta(:,:,:,1), kt
-            ! Diagonal, lower (i), upper (s)  (including the bottom boundary condition since avt is masked)
-! WRITE(numout,*) 'wslpi_crs', wslpi_crs(:,:,:)
-! WRITE(numout,*) 'wslpj_crs(ji,jj,jk-1)',wslpj_crs(:,:,:)
-! WRITE(numout,*) ' fsahtw',  fsahtw(:,:,:)
- !WRITE(numout,*) 'ah_wslp2', ah_wslp2(:,:,:) 
-! WRITE(numout,*) 'zwt2(ji,jj,jk-1)', zwt(:,:,:) 
-
             DO jk = 1, jpkm1
                DO jj = 2, jpjm1
                   DO ji = fs_2, fs_jpim1   ! vector opt.
-              !        ze3ta =  ( 1. - r_vvl ) +        r_vvl   * ocean_volume_crs_t(ji,jj,jk)   ! after scale factor at T-point
-             !         ze3tn =         r_vvl   + ( 1. - r_vvl ) * ocean_volume_crs_t(ji,jj,jk)   ! now   scale factor at T-point
                      ze3ta =  ( 1. - r_vvl ) +        r_vvl   * e3t_crs(ji,jj,jk)   ! after scale factor at T-point
                      ze3tn =         r_vvl   + ( 1. - r_vvl ) * e3t_crs(ji,jj,jk)   ! now   scale factor at T-point
-                     zwi(ji,jj,jk) = - p2dt(jk) * zwt(ji,jj,jk  ) / ( ze3tn * e3w_1d(jk  ) )  !cc
-                     zws(ji,jj,jk) = - p2dt(jk) * zwt(ji,jj,jk+1) / ( ze3tn * e3w_1d(jk+1) )  !cc
+                     !cbr zwi(ji,jj,jk) = - p2dt(jk) * zwt(ji,jj,jk  ) / ( ze3tn * e3w_1d(jk  ) )  !cc
+                     !cbr zws(ji,jj,jk) = - p2dt(jk) * zwt(ji,jj,jk+1) / ( ze3tn * e3w_1d(jk+1) )  !cc
+                     zwi(ji,jj,jk) = - p2dt(jk) * zwt(ji,jj,jk  ) / ( ze3tn * e3w_max_crs(ji,jj,jk) )
+                     zws(ji,jj,jk) = - p2dt(jk) * zwt(ji,jj,jk+1) / ( ze3tn * e3w_max_crs(ji,jj,jk+1) )
                      zwd(ji,jj,jk) = ze3ta - zwi(ji,jj,jk) - zws(ji,jj,jk)
-      !               WRITE(numout,*) 'ze3tn', ze3tn
-      !               WRITE(numout,*) 'e3w_0', e3w_0(jk)
-      !               WRITE(numout,*) 'ze3ta', ze3ta
-      !               WRITE(numout,*) 'zwt3(ji,jj,jk-1)', zwt(ji,jj,jk)
                  END DO
                END DO
             END DO
-  ! WRITE(numout,*) 'zwi(ji,jj,jk-1)', zwi(:,:,:)
-  ! WRITE(numout,*) 'zws(ji,jj,jk-1)', zws(:,:,:)
-  ! WRITE(numout,*) 'zwd(ji,jj,jk-1)', zwd(:,:,:) 
             !
             !! Matrix inversion from the first level
@@ -216,25 +196,17 @@
             !
          END IF
-! WRITE(numout,*) 'zwt4(ji,jj,jk-1)', zwt(:,:,:) 
          !    
-!WRITE(numout,*) 'test6456_trb_sbc4', pta(:,:,:,1), kt     
          ! second recurrence:    Zk = Yk - Ik / Tk-1  Zk-1
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1
-           !     ze3tb = ( 1. - r_vvl ) + r_vvl * ocean_volume_crs_t(ji,jj,1)
-           !     ze3tn = ( 1. - r_vvl ) + r_vvl * ocean_volume_crs_t(ji,jj,1)
                ze3tb = ( 1. - r_vvl ) + r_vvl * e3t_crs(ji,jj,1)
                ze3tn = ( 1. - r_vvl ) + r_vvl * e3t_crs(ji,jj,1)
                pta(ji,jj,1,jn) = ze3tb * ptb(ji,jj,1,jn) + p2dt(1) * ze3tn * pta(ji,jj,1,jn)
-!WRITE(numout,*) 'test6456_trb_sbc4', pta(:,:,:,1), kt 
-            END DO
-         END DO
-
-!WRITE(numout,*) 'kt', kt 
+            END DO
+         END DO
+
          DO jk = 2, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1
-           !        ze3tb = ( 1. - r_vvl ) + r_vvl * ocean_volume_crs_t(ji,jj,jk)
-           !        ze3tn = ( 1. - r_vvl ) + r_vvl * ocean_volume_crs_t(ji,jj,jk)
                   ze3tb = ( 1. - r_vvl ) + r_vvl * e3t_crs(ji,jj,jk)
                   ze3tn = ( 1. - r_vvl ) + r_vvl * e3t_crs(ji,jj,jk)
@@ -246,5 +218,4 @@
          END DO
 
-!WRITE(numout,*) 'test6456_trb_sbc5', pta(:,:,:,1), kt
          ! third recurrence:    Xk = (Zk - Sk Xk+1 ) / Tk   (result is the after tracer)
          DO jj = 2, jpjm1
@@ -267,6 +238,5 @@
       !                                               ! ================= !
       !
-!WRITE(numout,*) 'test6456_trb_sbc6', pta(:,:,:,1), kt
-      CALL wrk_dealloc( jpi, jpj, jpk, zwi, zwt ) 
+      CALL wrk_dealloc( jpi, jpj, jpk, zwi, zwt, zwd, zws ) 
       !
       IF( nn_timing == 1 )  CALL timing_stop('tra_zdf_imp_crs')
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/zpshde_crs.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/zpshde_crs.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/zpshde_crs.F90	(revision 5601)
@@ -103,5 +103,5 @@
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )  CALL timing_start( 'zps_hde')
+      IF( nn_timing == 1 )  CALL timing_start( 'zps_hde_crs')
       !
 !!      CALL wrk_alloc( jpi, jpj,       zri, zrj, zhi, zhj ) 
@@ -128,7 +128,5 @@
                ! i- direction
                IF( ze3wu >= 0._wp ) THEN      ! case 1
-                  !cbr zmaxu =  ze3wu / e3w_max_crs(ji+1,jj,iku)  
-                  zmaxu =  ze3wu
-                  IF( e3w_max_crs(ji+1,jj,iku) .NE. 0._wp ) zmaxu = zmaxu / e3w_max_crs(ji+1,jj,iku)
+                  zmaxu =  ze3wu / e3w_max_crs(ji+1,jj,iku)  
                  !    zmaxu =  ze3wu / e3w_crs(ji+1,jj,iku)
                   ! interpolated values of tracers
@@ -137,7 +135,5 @@
                   pgtu(ji,jj,jn) = umask_crs(ji,jj,1) * ( zti(ji,jj,jn) - pta(ji,jj,iku,jn) )
                ELSE                           ! case 2
-                  !cbr zmaxu = -ze3wu / e3w_max_crs(ji,jj,iku)
-                  zmaxu =  -ze3wu
-                  IF( e3w_max_crs(ji,jj,iku) .NE. 0._wp ) zmaxu = zmaxu / e3w_max_crs(ji,jj,iku)
+                  zmaxu = -ze3wu / e3w_max_crs(ji,jj,iku)
                  !    zmaxu = -ze3wu / e3w_crs(ji,jj,iku)
                   ! interpolated values of tracers
@@ -149,7 +145,5 @@
                ! j- direction
                IF( ze3wv >= 0._wp ) THEN      ! case 1
-                  !cbr zmaxv =  ze3wv / e3w_max_crs(ji,jj+1,ikv)
-                  zmaxv =  ze3wv
-                  IF( e3w_max_crs(ji,jj+1,ikv) .NE. 0._wp ) zmaxv =  zmaxv / e3w_max_crs(ji,jj+1,ikv)
+                  zmaxv =  ze3wv / e3w_max_crs(ji,jj+1,ikv)
                !      zmaxv =  ze3wv / e3w_crs(ji,jj+1,ikv)
                   ! interpolated values of tracers
@@ -158,7 +152,5 @@
                   pgtv(ji,jj,jn) = vmask_crs(ji,jj,1) * ( zte(ji,jj,jn) - pta(ji,jj,ikv,jn) )
                ELSE                           ! case 2
-                  !cbr zmaxv =  -ze3wv / e3w_max_crs(ji,jj,ikv)
-                  zmaxv =  -ze3wv
-                  IF( e3w_max_crs(ji,jj,ikv) .NE. 0._wp )zmaxv = zmaxv / e3w_max_crs(ji,jj,ikv)
+                  zmaxv =  -ze3wv / e3w_max_crs(ji,jj,ikv)
                 !     zmaxv = -ze3wv / e3w_crs(ji,jj,ikv)
                   ! interpolated values of tracers
@@ -237,5 +229,5 @@
       DEALLOCATE( zri , zrj, zte, zhi, zhj, zti)
       !
-      IF( nn_timing == 1 )  CALL timing_stop( 'zps_hde')
+      IF( nn_timing == 1 )  CALL timing_stop( 'zps_hde_crs')
       !
    END SUBROUTINE zps_hde_crs
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl.F90	(revision 5601)
@@ -83,4 +83,5 @@
       REAL(wp) ::   zN2_c        ! local scalar
       INTEGER, POINTER, DIMENSION(:,:) ::   imld   ! 2D workspace
+      REAL(wp), POINTER, DIMENSION(:,:) ::   z2d   ! 2D workspace
       !!----------------------------------------------------------------------
       !
@@ -88,4 +89,5 @@
       !
       CALL wrk_alloc( jpi,jpj, imld )
+      CALL wrk_alloc( jpi,jpj, z2d )
 
       IF( kt == nit000 ) THEN
@@ -135,4 +137,6 @@
          CALL iom_put( "mldr10_1", hmlp )   ! mixed layer depth
          CALL iom_put( "mldkz5"  , hmld )   ! turbocline depth
+         z2d(:,:)=REAL(nmln,wp) 
+         CALL iom_put( "nmln"  , z2d )   ! turbocline depth
       ENDIF
       
@@ -140,4 +144,5 @@
       !
       CALL wrk_dealloc( jpi,jpj, imld )
+      CALL wrk_dealloc( jpi,jpj, z2d )
       !
       IF( nn_timing == 1 )  CALL timing_stop('zdf_mxl')
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl_crs.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl_crs.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl_crs.F90	(revision 5601)
@@ -6,12 +6,16 @@
    !! History :  1.0  ! 2003-08  (G. Madec)  original code
    !!            3.2  ! 2009-07  (S. Masson, G. Madec)  IOM + merge of DO-loop
+   !!            3.7  ! 2012-03  (G. Madec)  make public the density criteria for trdmxl 
+   !!             -   ! 2014-02  (F. Roquet)  mixed layer depth calculated using N2 instead of rhop 
    !!----------------------------------------------------------------------
    !!   zdf_mxl      : Compute the turbocline and mixed layer depths.
    !!----------------------------------------------------------------------
-   USE oce             ! ocean dynamics and tracers variables
-   USE dom_oce         ! ocean space and time domain variables
+   !USE oce             ! ocean dynamics and tracers variables
+   !USE dom_oce         ! ocean space and time domain variables
+   !USE oce_trc
    USE zdf_oce         ! ocean vertical physics
    USE in_out_manager  ! I/O manager
    USE prtctl          ! Print control
+   USE phycst          ! physical constants
    USE iom             ! I/O library
    USE lib_mpp         ! MPP library
@@ -26,8 +30,5 @@
    PUBLIC   zdf_mxl_crs       ! called by step.F90
 
-   INTEGER , PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   nmln    !: number of level in the mixed layer (used by TOP)
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   hmld    !: mixing layer depth (turbocline)      [m]
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   hmlp    !: mixed layer depth  (rho=rho0+zdcrit) [m]
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   hmlpt   !: mixed layer depth at t-points        [m]
+   REAL(wp)         ::   avt_c = 5.e-4_wp   ! Kz criterion for the turbocline depth
 
    !! * Substitutions
@@ -35,24 +36,8 @@
    !!----------------------------------------------------------------------
    !! NEMO/OPA 4.0 , NEMO Consortium (2011)
-   !! $Id: zdfmxl.F90 3294 2012-01-28 16:44:18Z rblod $ 
+   !! $Id: zdfmxl.F90 4990 2014-12-15 16:42:49Z timgraham $ 
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 CONTAINS
-
-   INTEGER FUNCTION zdf_mxl_alloc_crs()
-      !!----------------------------------------------------------------------
-      !!               ***  FUNCTION zdf_mxl_alloc  ***
-      !!----------------------------------------------------------------------
-      zdf_mxl_alloc_crs = 0      ! set to zero if no array to be allocated
-      IF( .NOT. ALLOCATED( nmln_crs ) ) THEN
-         ALLOCATE( nmln_crs(jpi_crs,jpj_crs), hmld_crs(jpi_crs,jpj_crs), hmlp_crs(jpi_crs,jpj_crs) & !! declaration in crs.F90
-         &       , hmlpt_crs(jpi_crs,jpj_crs), STAT= zdf_mxl_alloc_crs )
-         !
-         IF( lk_mpp             )   CALL mpp_sum ( zdf_mxl_alloc_crs )
-         IF( zdf_mxl_alloc_crs /= 0 )   CALL ctl_warn('zdf_mxl_alloc: failed to allocate arrays.')
-         !
-      ENDIF
-   END FUNCTION zdf_mxl_alloc_crs
-
 
    SUBROUTINE zdf_mxl_crs( kt )
@@ -65,22 +50,21 @@
       !! ** Method  :   The mixed layer depth is the shallowest W depth with 
       !!      the density of the corresponding T point (just bellow) bellow a
-      !!      given value defined locally as rho(10m) + zrho_c
+      !!      given value defined locally as rho(10m) + rho_c
       !!               The turbocline depth is the depth at which the vertical
       !!      eddy diffusivity coefficient (resulting from the vertical physics
       !!      alone, not the isopycnal part, see trazdf.F) fall below a given
-      !!      value defined locally (avt_c here taken equal to 5 cm/s2)
+      !!      value defined locally (avt_c here taken equal to 5 cm/s2 by default)
       !!
       !! ** Action  :   nmln, hmld, hmlp, hmlpt
       !!----------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
-      !!
-      INTEGER  ::   ji, jj, jk          ! dummy loop indices
-      INTEGER  ::   iikn, iiki          ! temporary integer within a do loop
-      INTEGER, POINTER, DIMENSION(:,:) ::   imld                ! temporary workspace
-      REAL(wp) ::   zrho_c = 0.01_wp    ! density criterion for mixed layer depth
-      REAL(wp) ::   zavt_c = 5.e-4_wp   ! Kz criterion for the turbocline depth
+      !
+      INTEGER  ::   ji, jj, jk   ! dummy loop indices
+      INTEGER  ::   iiki,iikn   ! local integer
+      REAL(wp) ::   zN2_c        ! local scalar
+      INTEGER, POINTER, DIMENSION(:,:) ::   imld   ! 2D workspace
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )  CALL timing_start('zdf_mxl')
+      IF( nn_timing == 1 )  CALL timing_start('zdf_mxl_crs')
       !
       CALL wrk_alloc( jpi_crs,jpj_crs, imld )
@@ -88,44 +72,33 @@
       IF( kt == nit000 ) THEN
          IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'zdf_mxl : mixed layer depth'
+         IF(lwp) WRITE(numout,*) 'zdf_mxl_crs : mixed layer depth'
          IF(lwp) WRITE(numout,*) '~~~~~~~ '
-         !                             ! allocate zdfmxl arrays
-         IF( zdf_mxl_alloc_crs() /= 0 )   CALL ctl_stop( 'STOP', 'zdf_mxl : unable to allocate arrays' )
       ENDIF
 
-      ! w-level of the mixing and mixed layers
-      nmln_crs(:,:) = mbkt_crs(:,:) + 1        ! Initialization to the number of w ocean point
-      imld(:,:)     = mbkt_crs(:,:) + 1
-      DO jk = jpkm1, nlb10, -1         ! from the bottom to nlb10
+      ! w-level of the turbocline
+      imld(:,:)=0
+      DO jk = jpkm1, nlb10, -1         ! from the bottom to nlb10 
          DO jj = 1, jpj_crs
             DO ji = 1, jpi_crs
-               IF( rhop_crs(ji,jj,jk) > rhop_crs(ji,jj,nla10) + zrho_c )   nmln_crs(ji,jj) = jk      ! Mixed layer
-        !       IF( avt (ji,jj,jk) < zavt_c                     )   imld(ji,jj) = jk      ! Turbocline 
+               IF( avt_crs (ji,jj,jk) < avt_c )   imld(ji,jj) = MAX( jk, 1 )      ! Turbocline 
             END DO
          END DO
       END DO
+
       ! depth of the mixing and mixed layers
-      !write(narea+2000,*)"nlb10 ",nlb10,SHAPE(hmlpt_crs),SHAPE(gdepw_crs) ; call flush(narea+2000)
+      hmld_crs(:,:) = 0._wp
+      hmlpt_crs(:,:) = 0._wp
       DO jj = 1, jpj_crs
          DO ji = 1, jpi_crs
-           ! iiki = imld(ji,jj)
+            iiki = imld(ji,jj)
             iikn = nmln_crs(ji,jj)
-            ! write(narea+2000,*)ji,jj,iikn,gdept_crs(ji,jj,iikn-1) ; call flush(narea+2000)
-       !     hmld (ji,jj) = gdepw_crs(ji,jj,iiki  ) * tmask_crs(ji,jj,1)    ! Turbocline depth 
-            !IF( iikn .LT. 2 .OR. iikn .GT. jpk )write(narea+2000,*)"iikn ",ji,jj,iikn ; call flush(narea+2000)
-            hmlp_crs (ji,jj) = gdepw_crs(ji,jj,iikn  ) * tmask_crs(ji,jj,1)    ! Mixed layer depth
-            hmlpt_crs(ji,jj) = gdept_crs(ji,jj,iikn-1)                     ! depth of the last T-point inside the mixed layer
+            IF( iiki .NE. 0 ) hmld_crs (ji,jj) = ( gdepw_crs(ji,jj,iiki  ) - gdepw_crs(ji,jj,1 )            )   * tmask_crs(ji,jj,1)  ! Turbocline depth 
+            IF( iiki .NE. 0 ) hmlpt_crs(ji,jj) = ( gdept_crs(ji,jj,iikn-1) - gdepw_crs(ji,jj,1 )            )   * tmask_crs(ji,jj,1)  ! depth of the last T-point inside the mixed layer
          END DO
       END DO
-      IF( .NOT.lk_offline ) THEN            ! no need to output in offline mode
-  !       CALL iom_put( "mldr10_1", hmlp )   ! mixed layer depth
-   !      CALL iom_put( "mldkz5"  , hmld )   ! turbocline depth
-      ENDIF
-      
-    !  IF(ln_ctl)   CALL prt_ctl( tab2d_1=REAL(nmln,wp), clinfo1=' nmln : ', tab2d_2=hmlp, clinfo2=' hmlp : ', ovlap=1 )
       !
       CALL wrk_dealloc( jpi_crs,jpj_crs, imld )
       !
-      IF( nn_timing == 1 )  CALL timing_stop('zdf_mxl')
+      IF( nn_timing == 1 )  CALL timing_stop('zdf_mxl_crs')
       !
    END SUBROUTINE zdf_mxl_crs
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 5601)
@@ -82,4 +82,5 @@
    USE crsini          ! initialise grid coarsening utility
    USE lbcnfd, ONLY: isendto, nsndto, nfsloop, nfeloop ! Setup of north fold exchanges 
+   USE trabbl_crs
 
    IMPLICIT NONE
@@ -114,4 +115,5 @@
       !!----------------------------------------------------------------------
       INTEGER ::   istp       ! time step index
+      CHARACTER(len=20) :: cmd 
       !!----------------------------------------------------------------------
       !
@@ -410,5 +412,5 @@
       IF( lk_ldfslp     )   CALL ldf_slp_init      ! slope of lateral mixing
       !
-      IF( ln_crs .AND. lk_ldfslp ) THEN
+      IF( ln_crs_top .AND. lk_ldfslp ) THEN
                             CALL dom_grid_crs
                             CALL ldf_slp_init_crs
@@ -420,5 +422,5 @@
       IF( lk_trabbl     )   CALL tra_bbl_init   ! advective (and/or diffusive) bottom boundary layer scheme
       !
-      IF( ln_crs .AND. lk_trabbl     )  THEN
+      IF( ln_crs_top .AND. lk_trabbl     )  THEN
                             CALL dom_grid_crs 
                             CALL tra_bbl_init_crs   ! advective (and/or diffusive) bottom boundary layer scheme
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/step.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 5601)
@@ -110,6 +110,6 @@
       !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       !  THERMODYNAMICS
-                         CALL eos_rab( tsb, rab_b )       ! before local thermal/haline expension ratio at T-points
-                         CALL eos_rab( tsn, rab_n )       ! now    local thermal/haline expension ratio at T-points
+                         !cbr not used CALL eos_rab( tsb, rab_b )       ! before local thermal/haline expension ratio at T-points
+                         !cbr not used CALL eos_rab( tsn, rab_n )       ! now    local thermal/haline expension ratio at T-points
                          CALL bn2    ( tsb, rab_b, rn2b ) ! before Brunt-Vaisala frequency
                          CALL bn2    ( tsn, rab_n, rn2  ) ! now    Brunt-Vaisala frequency
@@ -139,5 +139,4 @@
                          CALL zdf_mxl( kstp )         ! mixed layer depth
 
-      IF(ln_crs)         CALL zdf_mxl_crs(kstp)
                                                       ! write TKE or GLS information in the restart file
       IF( lrst_oce .AND. lk_zdftke )   CALL tke_rst( kstp, 'WRITE' )
@@ -154,4 +153,8 @@
                          CALL ldf_slp_grif( kstp )
          ELSE
+                         CALL iom_put("rabt",rab_n(:,:,:,jp_tem))
+                         CALL iom_put("rabs",rab_n(:,:,:,jp_sal))
+                         CALL iom_put("rhd",rhd)
+                         CALL iom_put("rn2b",rn2b)
                          CALL ldf_slp( kstp, rhd, rn2b )     ! before slope for Madec operator
          ENDIF
@@ -228,12 +231,17 @@
       IF( ln_crs )   THEN
                          CALL dom_grid_crs
-                         CALL eos_crs(tsb_crs , rhd_crs, rhop_crs)
-                         CALL bn2_crs(tsb_crs , rb2_crs)
-         IF( ln_zps )    CALL zps_hde_crs( kstp, 2, tsb_crs, gtsu_crs, gtsv_crs, rhd_crs, gru_crs, grv_crs )
-                         CALL zdf_mxl_crs(kstp)
+
+                         CALL eos_rab_crs( tsn_crs, rab_crs_n )       ! now    local thermal/haline expension ratio at T-points
+                         CALL bn2_crs    ( tsn_crs, rab_crs_n, rb2_crs  ) ! now    Brunt-Vaisala frequency
+                         CALL eos_crs ( tsn_crs, rhd_crs, rhop_crs, gdept_crs(:,:,:) ) ! now in situ density for hpg computation
+
+         IF( ln_zps )    CALL zps_hde_crs( kstp, jpts, tsb_crs, gtsu_crs, gtsv_crs, rhd_crs, gru_crs, grv_crs )
+
          IF( lk_ldfslp .AND.  .NOT. ln_traldf_grif )  &
                          CALL ldf_slp_crs( kstp, rhd_crs, rb2_crs )
                          CALL dom_grid_glo
-      ENDIF
+
+      ENDIF
+                         CALL zdf_mxl_crs(kstp)
 
       IF( ln_crs_top )   CALL dom_grid_crs
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcini_my_trc.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcini_my_trc.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcini_my_trc.F90	(revision 5601)
@@ -16,4 +16,5 @@
    USE trc
    USE trcsms_my_trc
+   USE dom_oce, ONLY : gdepw_1d,e3t_1d,nyear_len
 
    IMPLICIT NONE
@@ -44,5 +45,14 @@
       IF(lwp) WRITE(numout,*) ' trc_ini_my_trc: initialisation of MY_TRC model'
       IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~'
+
+      nlb_age = MINLOC( gdepw_1d, mask = gdepw_1d > age_depth, dim = 1  )
+      nl_age = nlb_age - 1
+      nla_age = nl_age - 1
+      frac_kill_age = (age_depth - gdepw_1d(nl_age))/e3t_1d(nl_age)
+      frac_add_age = 1._wp -  frac_kill_age
+      rryear = 1._wp / ( nyear_len(1) * rday )
+
       
+      IF( .NOT. ln_rsttr ) trb(:,:,:,jp_myt0:jp_myt1) = 0.
       IF( .NOT. ln_rsttr ) trn(:,:,:,jp_myt0:jp_myt1) = 0.
       !
